=== debian/changelog ===
lv2 (1.0.0~dfsg2-2) unstable; urgency=low

  * Breaks/Replaces on lv2-extensions-good rather than Conflicts/Replaces.

 -- Alessio Treglia <alessio@debian.org>  Sat, 05 May 2012 01:56:58 +0200

lv2 (1.0.0~dfsg2-1) unstable; urgency=low

  * Initial release. (Closes: #669232)

 -- Alessio Treglia <alessio@debian.org>  Wed, 18 Apr 2012 12:12:33 +0200
