=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

WAF = ./waf

PLUGINS = amp sampler

%:
	dh $@

override_dh_auto_configure:
	$(WAF) configure --prefix=/usr \
		--mandir=/usr/share/man \
		--strict \
		--debug

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) clean || true
	find -name "*.pyc" -delete
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install
	for plugin in $(PLUGINS); do \
		rm -rf debian/lv2-dev/usr/lib/lv2/eg-$${plugin}.lv2 ; \
	done

override_dh_installchangelogs:
	dh_installchangelogs NEWS
