=== debian/changelog ===
lv2 (1.2.0~dfsg1-1) experimental; urgency=low

  * New upstream release.
  * Add get-orig-source target to strip out waf.

 -- Alessio Treglia <alessio@debian.org>  Fri, 19 Oct 2012 09:49:54 +0100
