## lv2 1.4.0~dfsg1

=== wscript ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 # Variables for 'waf dist'
 APPNAME = 'lv2'
-VERSION = '1.2.0'
+VERSION = '1.4.0'
 
 # Mandatory variables
 top = '.'
@@ -40,11 +40,11 @@
         Options.options.build_tests = False
         Options.options.no_plugins = True
 
+    if Options.options.online_docs:
+        Options.options.docs = True
+
     autowaf.configure(conf)
     autowaf.set_c99_mode(conf)
-
-    if Options.options.online_docs and Options.options.docs:
-        conf.fatal('At most one of --online-docs and --docs may be given')
 
     if Options.platform == 'win32' or not hasattr(os.path, 'relpath'):
         Logs.warn('System does not support linking headers, copying')
@@ -55,6 +55,13 @@
     conf.env.COPY_HEADERS  = Options.options.copy_headers
     conf.env.ONLINE_DOCS   = Options.options.online_docs
 
+    if conf.env.DOCS or conf.env.ONLINE_DOCS:
+        try:
+            conf.find_program('asciidoc')
+            conf.env.BUILD_BOOK = True
+        except:
+            Logs.warn('Asciidoc not found, book will not be built')
+
     # Check for gcov library (for test coverage)
     if conf.env.BUILD_TESTS and not conf.is_defined('HAVE_GCOV'):
         conf.check_cc(lib='gcov', define_name='HAVE_GCOV', mandatory=False)
@@ -65,7 +72,7 @@
 
     conf.env.LV2_BUILD = ['lv2/lv2plug.in/ns/lv2core']
     if conf.env.BUILD_PLUGINS:
-        for i in conf.path.ant_glob('plugins/*', dir=True):
+        for i in conf.path.ant_glob('plugins/*', src=False, dir=True):
             try:
                 conf.recurse(i.srcpath())
                 conf.env.LV2_BUILD += [i.srcpath()]
@@ -308,9 +315,12 @@
     for i in bld.env.LV2_BUILD:
         bld.recurse(i)
 
-    if bld.env.DOCS:
+    if bld.env.BUILD_BOOK:
+        bld.recurse('plugins')
+
+    if bld.env.DOCS or bld.env.ONLINE_DOCS:
         # Build Doxygen documentation (and tags file)
-        autowaf.build_dox(bld, 'LV2', VERSION, top, out, 'lv2plug.in/doc')
+        autowaf.build_dox(bld, 'LV2', VERSION, top, out, 'lv2plug.in/doc', False)
 
         # Copy stylesheet to build directory
         bld(features = 'subst',
@@ -353,9 +363,3 @@
             bld.add_group()  # Barrier (don't call lv2specgen in parallel)
 
             # Call lv2specgen to generate spec docs
-            bld(rule   = specgen,
-                name   = 'specgen',
-                source = os.path.join(i.srcpath(), name + '.ttl'),
-                target = ['%s/%s.html' % (chop_lv2_prefix(i.srcpath()), name),
-                          index_file])
-
