=== debian/changelog ===
lv2 (1.4.0~dfsg1-2) unstable; urgency=low

  * Upload to unstable.

 -- Alessio Treglia <alessio@debian.org>  Mon, 06 May 2013 11:16:26 +0200

lv2 (1.4.0~dfsg1-1) experimental; urgency=low

  * New upstream release.
  * Fix Vcs fields.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Wed, 06 Mar 2013 13:26:05 +0000
