=== debian/control ===
--- 
+++ 
@@ -11,9 +11,9 @@
  perl,
  pkg-config,
  python
-Standards-Version: 3.9.3
-Vcs-Git: git://git.debian.org/git/pkg-multimedia/lv2.git
-Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/lv2.git
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/pkg-multimedia/lv2.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/lv2.git
 Homepage: http://lv2plug.in/
 
 Package: lv2-dev
