## lv2 1.6.0~dfsg0

=== debian/changelog ===
lv2 (1.6.0~dfsg0-1) unstable; urgency=low

  [ Alessio Treglia ]
  * New upstream release.

  [ Jaromír Mikeš ]
  * Added myself as uploader

 -- Alessio Treglia <alessio@debian.org>  Tue, 27 Aug 2013 17:56:31 +0100
